#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include "bfi.h"

char *getarg(const char *command);
int doexit();
int dofile(const char *command);
int domode(const char *command);
int dorun();
int execute(char c);
int reinit();
int verify();
int empty_stdin();

int carryout(const char *command){
	if (strncmp(command, "exit", 4) == 0){
		doexit();
		} else if (strncmp(command, "file ", 5) == 0){
		dofile(command);
		} else if (strncmp(command, "mode ", 5) == 0){
		domode(command);
		} else if (strncmp(command, "run", 3) == 0){
		dorun();
		emptystdin();	// empty standard input
		} else if (strncmp(command, "\n", 3) == 0){
		} else {
		printf("Invalid command\n");
		}

	return 0;
	}

int dorun(){
	char c;

	if (sourcefile == NULL){
		printf("Error: No file loaded");
		return -2;
		}

	reinit();
	if (verify() == -1){
		return -3;
		}

	reinit();

	while (!feof(sourcefile)){
		c = fgetc(sourcefile);
		if (execute(c) == -1){
			return -1;
			}
		}

	printf("\n");

	return 0;
	}

int domode(const char *command){
	char *p;
	char mode[256];

	p=getarg(command);
	strcpy(mode, p);

	if (strcmp(mode, "anal") == 0){
		curmode = anal;
		} else if (strcmp(mode, "vaginal") ==  0){
		curmode = vaginal;
		} else {
		printf("Error: Invalid mode selected\n");
		}

	return 0;
	}

int dofile(const char *command){
	char fname[256];
	char *p;

	// If there is already another source file open, close it
	if (sourcefile != NULL){
		fclose(sourcefile);
		}

	p = getarg(command);
	strcpy(fname, p);
	strcat(fname, ".bf");
	sourcefile = fopen(fname, "r");

	// Boring error-checking crap
	if (sourcefile == NULL){
		perror("Error");
		}

	return 0;
	}

int doexit(){
	exit(0);
	}
